// realworld_test.dart
// PropertyListSerialization Copyright © 2021; Electric Bolt Limited.

import 'package:propertylistserialization/propertylistserialization.dart';
import 'package:test/test.dart';

import 'binarypropertylistreader_test.dart';

void main() {
  test('iOSAppXMLPlist', () {
    var template = '<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n'
        '<!DOCTYPE plist PUBLIC \"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n'
        '<plist version=\"1.0\">\n'
        '<dict>\n'
        '\t<key>CFBundleDevelopmentRegion</key>\n'
        '\t<string>en</string>\n'
        '\t<key>CFBundleDisplayName</key>\n'
        '\t<string>\${PRODUCT_NAME}</string>\n'
        '\t<key>CFBundleDocumentTypes</key>\n'
        '\t<array>\n'
        '\t\t<dict>\n'
        '\t\t\t<key>CFBundleTypeIconFiles</key>\n'
        '\t\t\t<array>\n'
        '\t\t\t\t<string>DocumentIcon.png</string>\n'
        '\t\t\t\t<string>DocumentIcon320.png</string>\n'
        '\t\t\t</array>\n'
        '\t\t\t<key>CFBundleTypeName</key>\n'
        '\t\t\t<string>Appfigurate app</string>\n'
        '\t\t\t<key>CFBundleTypeRole</key>\n'
        '\t\t\t<string>Editor</string>\n'
        '\t\t\t<key>LSHandlerRank</key>\n'
        '\t\t\t<string>Owner</string>\n'
        '\t\t\t<key>LSItemContentTypes</key>\n'
        '\t\t\t<array>\n'
        '\t\t\t\t<string>nz.co.electricbolt.appfigurate.apc</string>\n'
        '\t\t\t</array>\n'
        '\t\t</dict>\n'
        '\t</array>\n'
        '\t<key>CFBundleExecutable</key>\n'
        '\t<string>\${EXECUTABLE_NAME}</string>\n'
        '\t<key>CFBundleIcons</key>\n'
        '\t<dict/>\n'
        '\t<key>CFBundleIdentifier</key>\n'
        '\t<string>\$(PRODUCT_BUNDLE_IDENTIFIER)</string>\n'
        '\t<key>CFBundleInfoDictionaryVersion</key>\n'
        '\t<string>6.0</string>\n'
        '\t<key>CFBundleName</key>\n'
        '\t<string>\${PRODUCT_NAME}</string>\n'
        '\t<key>CFBundlePackageType</key>\n'
        '\t<string>APPL</string>\n'
        '\t<key>CFBundleShortVersionString</key>\n'
        '\t<string>1.0.1</string>\n'
        '\t<key>CFBundleSignature</key>\n'
        '\t<string>????</string>\n'
        '\t<key>CFBundleURLTypes</key>\n'
        '\t<array>\n'
        '\t\t<dict>\n'
        '\t\t\t<key>CFBundleURLName</key>\n'
        '\t\t\t<string>nz.co.electricbolt.appfigurate</string>\n'
        '\t\t\t<key>CFBundleURLSchemes</key>\n'
        '\t\t\t<array>\n'
        '\t\t\t\t<string>appfigurate</string>\n'
        '\t\t\t\t<string>appfigurate1</string>\n'
        '\t\t\t</array>\n'
        '\t\t</dict>\n'
        '\t</array>\n'
        '\t<key>CFBundleVersion</key>\n'
        '\t<string>1.0.1.1000</string>\n'
        '\t<key>LSRequiresIPhoneOS</key>\n'
        '\t<true/>\n'
        '\t<key>NSFaceIDUsageDescription</key>\n'
        '\t<string>Use Face ID to authenticate</string>\n'
        '\t<key>UILaunchStoryboardName</key>\n'
        '\t<string>LaunchScreen</string>\n'
        '\t<key>UIRequiredDeviceCapabilities</key>\n'
        '\t<array>\n'
        '\t\t<string>armv7</string>\n'
        '\t</array>\n'
        '\t<key>UIStatusBarHidden</key>\n'
        '\t<false/>\n'
        '\t<key>UIStatusBarStyle</key>\n'
        '\t<string>UIStatusBarStyleBlackTranslucent</string>\n'
        '\t<key>UISupportedInterfaceOrientations</key>\n'
        '\t<array>\n'
        '\t\t<string>UIInterfaceOrientationPortrait</string>\n'
        '\t\t<string>UIInterfaceOrientationLandscapeLeft</string>\n'
        '\t\t<string>UIInterfaceOrientationLandscapeRight</string>\n'
        '\t\t<string>UIInterfaceOrientationPortraitUpsideDown</string>\n'
        '\t</array>\n'
        '\t<key>UISupportedInterfaceOrientations~ipad</key>\n'
        '\t<array>\n'
        '\t\t<string>UIInterfaceOrientationPortrait</string>\n'
        '\t\t<string>UIInterfaceOrientationPortraitUpsideDown</string>\n'
        '\t\t<string>UIInterfaceOrientationLandscapeLeft</string>\n'
        '\t\t<string>UIInterfaceOrientationLandscapeRight</string>\n'
        '\t</array>\n'
        '\t<key>UIViewControllerBasedStatusBarAppearance</key>\n'
        '\t<false/>\n'
        '\t<key>UTExportedTypeDeclarations</key>\n'
        '\t<array>\n'
        '\t\t<dict>\n'
        '\t\t\t<key>UTTypeConformsTo</key>\n'
        '\t\t\t<array>\n'
        '\t\t\t\t<string>public.data</string>\n'
        '\t\t\t</array>\n'
        '\t\t\t<key>UTTypeDescription</key>\n'
        '\t\t\t<string>Appfigurate app</string>\n'
        '\t\t\t<key>UTTypeIconFiles</key>\n'
        '\t\t\t<array>\n'
        '\t\t\t\t<string>DocumentIcon</string>\n'
        '\t\t\t\t<string>DocumentIcon320</string>\n'
        '\t\t\t</array>\n'
        '\t\t\t<key>UTTypeIdentifier</key>\n'
        '\t\t\t<string>nz.co.electricbolt.appfigurate.apc</string>\n'
        '\t\t\t<key>UTTypeSize320IconFile</key>\n'
        '\t\t\t<string>DocumentIcon320</string>\n'
        '\t\t\t<key>UTTypeSize64IconFile</key>\n'
        '\t\t\t<string>DocumentIcon</string>\n'
        '\t\t\t<key>UTTypeTagSpecification</key>\n'
        '\t\t\t<dict>\n'
        '\t\t\t\t<key>public.filename-extension</key>\n'
        '\t\t\t\t<array>\n'
        '\t\t\t\t\t<string>apc</string>\n'
        '\t\t\t\t</array>\n'
        '\t\t\t</dict>\n'
        '\t\t</dict>\n'
        '\t</array>\n'
        '</dict>\n'
        '</plist>\n';

    var rootDict = PropertyListSerialization.propertyListWithString(template) as
      Map<String,Object>;
    expect(rootDict['CFBundleDevelopmentRegion'], equals('en'));

    var docTypes = rootDict['CFBundleDocumentTypes'] as List;
    var docTypesDict = docTypes[0] as Map<String, Object>;
    var iconFiles = docTypesDict['CFBundleTypeIconFiles'] as List;
    expect(iconFiles[1], equals('DocumentIcon320.png'));

    expect(rootDict['UIStatusBarHidden'], equals(false));

    var exportedTypeDecls = rootDict['UTExportedTypeDeclarations'] as List;
    var exportedTypeDeclsDict = exportedTypeDecls[0] as Map<String, Object>;
    var specsDict = exportedTypeDeclsDict['UTTypeTagSpecification'] as
    Map<String, Object>;
    var extensions = specsDict['public.filename-extension'] as List;
    expect(extensions[0], equals('apc'));

    // Ensure serialization produces identical string as template.
    var newStr = PropertyListSerialization.stringWithPropertyList(rootDict);
    expect(template, equals(newStr));
  });

  test('iOSAppBinaryPlist', () {
    var template = '62706c6973743030df10170102030405060708090a0b0c0d0e0f1011121'
        '31415161718191a1b1c1d1e2d2e2f3031323439411d4243555618575c434642756e646'
        'c654e616d655f101655494c61756e636853746f7279626f6172644e616d655f1019434'
        '642756e646c65446576656c6f706d656e74526567696f6e5f100f434642756e646c655'
        '6657273696f6e5f101055495374617475734261725374796c655f10115549537461747'
        '57342617248696464656e5f1015434642756e646c65446f63756d656e7454797065735'
        'f1013434642756e646c655061636b616765547970655f10184e5346616365494455736'
        '167654465736372697074696f6e5f101a434642756e646c6553686f727456657273696'
        'f6e537472696e675f101d434642756e646c65496e666f44696374696f6e61727956657'
        '273696f6e5f1012434642756e646c6545786563757461626c655f101c5549526571756'
        '97265644465766963654361706162696c69746965735f10255549537570706f7274656'
        '4496e746572666163654f7269656e746174696f6e737e697061645f1010434642756e6'
        '46c6555524c54797065735f1012434642756e646c654964656e7469666965725f10285'
        '54956696577436f6e74726f6c6c6572426173656453746174757342617241707065617'
        '2616e63655f1011434642756e646c655369676e61747572655f101a55544578706f727'
        '46564547970654465636c61726174696f6e735d434642756e646c6549636f6e735f101'
        '24c5352657175697265734950686f6e654f535f1013434642756e646c65446973706c6'
        '1794e616d655f10205549537570706f72746564496e746572666163654f7269656e746'
        '174696f6e735f100f247b50524f445543545f4e414d457d5c4c61756e6368536372656'
        '56e52656e5a312e302e312e313030305f102055495374617475734261725374796c654'
        '26c61636b5472616e736c7563656e7408a11fd520212223242526292b2c5f101043464'
        '2756e646c65547970654e616d655f1015434642756e646c655479706549636f6e46696'
        'c65735f10124c534974656d436f6e74656e7454797065735f1010434642756e646c655'
        '4797065526f6c655d4c5348616e646c657252616e6b5f100f417070666967757261746'
        '520617070a227285f1010446f63756d656e7449636f6e2e706e675f1013446f63756d6'
        '56e7449636f6e3332302e706e67a12a5f10226e7a2e636f2e656c656374726963626f6'
        'c742e61707066696775726174652e61706356456469746f72554f776e6572544150504'
        'c5f101b557365204661636520494420746f2061757468656e74696361746555312e302'
        'e3153362e305f1012247b45584543555441424c455f4e414d457da1335561726d7637a'
        '4353637385f101e5549496e746572666163654f7269656e746174696f6e506f7274726'
        '169745f10285549496e746572666163654f7269656e746174696f6e506f72747261697'
        '4557073696465446f776e5f10235549496e746572666163654f7269656e746174696f6'
        'e4c616e6473636170654c6566745f10245549496e746572666163654f7269656e74617'
        '4696f6e4c616e6473636170655269676874a13ad23b3c3d3e5f100f434642756e646c6'
        '555524c4e616d655f1012434642756e646c6555524c536368656d65735f101e6e7a2e6'
        '36f2e656c656374726963626f6c742e6170706669677572617465a23f405b617070666'
        '96775726174655c6170706669677572617465315f101c242850524f445543545f42554'
        'e444c455f4944454e54494649455229543f3f3f3fa144d745464748494a4b4c4d4f2a2'
        '550515f101555545479706553697a6533323049636f6e46696c655f101055545479706'
        '5436f6e666f726d73546f5f100f55545479706549636f6e46696c65735f10105554547'
        '970654964656e7469666965725f10115554547970654465736372697074696f6e5f101'
        '455545479706553697a65363449636f6e46696c655f101655545479706554616753706'
        '563696669636174696f6e5f100f446f63756d656e7449636f6e333230a14e5b7075626'
        'c69632e64617461a2504c5c446f63756d656e7449636f6ed152535f10197075626c696'
        '32e66696c656e616d652d657874656e73696f6ea15453617063d009a43537383600080'
        '0390046005f007b008d00a000b400cc00e200fd011a013a014f016e019601a901be01e'
        '901fd021a0228023d0253027602880295029802a302c602c702c902d402e702ff03140'
        '32703350347034a035d03730375039a03a103a703ac03ca03d003d403e903eb03f103f'
        '6041704420468048f0491049604a804bd04de04e104ed04fa0519051e0520052f05470'
        '55a056c057f059305aa05c305d505d705e305e605f305f60612061406180619061a000'
        '000000000020100000000000000580000000000000000000000000000061f';

    var templateBinary = bytes(template);

    var rootDict = PropertyListSerialization.propertyListWithData(
        templateBinary) as Map<String,Object>;
    expect(rootDict['CFBundleDevelopmentRegion'], equals('en'));

    var docTypes = rootDict['CFBundleDocumentTypes'] as List;
    var docTypesDict = docTypes[0] as Map<String, Object>;
    var iconFiles = docTypesDict['CFBundleTypeIconFiles'] as List;
    expect(iconFiles[1], equals('DocumentIcon320.png'));

    expect(rootDict['UIStatusBarHidden'], equals(false));

    var exportedTypeDecls = rootDict['UTExportedTypeDeclarations'] as List;
    var exportedTypeDeclsDict = exportedTypeDecls[0] as Map<String, Object>;
    var specsDict = exportedTypeDeclsDict['UTTypeTagSpecification'] as
      Map<String, Object>;
    var extensions = specsDict['public.filename-extension'] as List;
    expect(extensions[0], equals('apc'));

    // Ensure serialization produces identical binary as template.
    var newBinary = PropertyListSerialization.dataWithPropertyList(rootDict);

    expectByteData(templateBinary, newBinary);
  });

  var template =
      '<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n'
      '<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">\n'
      '<plist version=\"1.0\">\n'
      '<dict>\n'
      '\t<key>DocumentWindowFrame</key>\n'
      '\t<string>{{22, -0}, {599, 1057}}</string>\n'
      '\t<key>ExtensionLastUpdate</key>\n'
      '\t<date>2018-01-20T01:35:52Z</date>\n'
      '\t<key>FindBannerVisible</key>\n'
      '\t<false/>\n'
      '\t<key>FindDefaults</key>\n'
      '\t<dict>\n'
      '\t\t<key>IgnoreCase</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>LargeInterface</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>Multiline</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>RegEx</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>Scope2.0</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseYenSymbol2.0</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>Wrap</key>\n'
      '\t\t<true/>\n'
      '\t</dict>\n'
      '\t<key>FindDefaults.ExpandedHeight</key>\n'
      '\t<integer>73</integer>\n'
      '\t<key>HockeySDKAutomaticallySendCrashReports</key>\n'
      '\t<false/>\n'
      '\t<key>HockeySDKCrashReportActivated</key>\n'
      '\t<true/>\n'
      '\t<key>LastRunVersion</key>\n'
      '\t<integer>0</integer>\n'
      '\t<key>LastRunVersionString</key>\n'
      '\t<string>2.6.9</string>\n'
      '\t<key>LastSelectedPreferencePaneIdentifier</key>\n'
      '\t<string>preferences.Sharing</string>\n'
      '\t<key>LastSelectedPreferencePaneIdentifier:SelectedPaneIdentifier</key>\n'
      '\t<string>preferences.General</string>\n'
      '\t<key>ModePrecedences</key>\n'
      '\t<array>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.PHP-HTML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>PHP-HTML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>php</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>php3</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>php4</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>php5</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>phtml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>inc</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/php</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/env php</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>&lt;\\?php.+(?:\\?&gt;|\\Z)</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>&lt;\\?.+(?:\\?&gt;|\\Z)</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>4.0</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.ERB</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>ERB</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rhtml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>erb</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Ruby</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Ruby</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rb</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>ruby</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rbx</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rxml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>builder</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rjs</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>Rakefile</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>1</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/(env )?ruby</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5.1</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Diff</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Diff</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>diff</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>patch</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>Index:[^\\n]*\\n={67}</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>^@@ [-+\\d,]+ [-+\\d,]+ @@</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.HTML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>HTML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>html</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>shtml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>htm</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>xhtml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>shtm</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A&lt;!DOCTYPE (?i:HTML)</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A&lt;(?i:html)</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.CSS</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>CSS</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>css</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>sss</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.JavaScript</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>JavaScript</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>js</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>javascript</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>jsx</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>json</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5.2</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.XML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>XML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>xml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>xslt</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>xsl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>xsd</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>wsdl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>svg</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>plist</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rss</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>rdf</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>seestyle</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>scriptSuite</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>scriptTerminology</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A&lt;\\?xml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Perl</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Perl</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>pl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>perl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>pm</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/(env )?perl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5.1</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Lua</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Lua</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>lua</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr(/local)?/bin/lua</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/env lua</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.ActionScript</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>ActionScript</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>as</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n';

  var template2 =
      '\t\t\t<string>SEEMode.Java</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Java</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>java</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>4.0</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Python</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Python</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>py</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>pw</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>pyw</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>python</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>cpt</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A#!/usr/bin/(env )?python</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.SQL</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>SQL</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>sql</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>mysql</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>postgresql</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.LassoScript-HTML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>LassoScript-HTML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>lasso</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>lhtml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>las</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A&lt;\\?[Ll]assoScript</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>\\A\\[[^\\[]</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>2</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Smarty</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Smarty</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>tpl</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>1.0</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Objective-J</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Objective-J</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>j</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.YAML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>YAML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>yml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>yaml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>1.0</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.JSP-HTML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>JSP-HTML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>jsp</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>jspx</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>sqljsp</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.ASP-HTML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>ASP-HTML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>asp</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>vbs</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>aspx</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.6</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Base</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Default</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>txt</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.CFML</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>CFML</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>cfm</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>cfc</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>cfr</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>cfml</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>3.5</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.LESS</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>LESS</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>less</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>1.0</string>\n'
      '\t\t</dict>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Identifier</key>\n'
      '\t\t\t<string>SEEMode.Sass</string>\n'
      '\t\t\t<key>Location</key>\n'
      '\t\t\t<string>Built-In</string>\n'
      '\t\t\t<key>Name</key>\n'
      '\t\t\t<string>Sass</string>\n'
      '\t\t\t<key>Rules</key>\n'
      '\t\t\t<array>\n'
      '\t\t\t\t<dict>\n'
      '\t\t\t\t\t<key>Enabled</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>ModeRule</key>\n'
      '\t\t\t\t\t<true/>\n'
      '\t\t\t\t\t<key>Overridden</key>\n'
      '\t\t\t\t\t<false/>\n'
      '\t\t\t\t\t<key>OverriddenTooltip</key>\n'
      '\t\t\t\t\t<string></string>\n'
      '\t\t\t\t\t<key>String</key>\n'
      '\t\t\t\t\t<string>scss</string>\n'
      '\t\t\t\t\t<key>TypeIdentifier</key>\n'
      '\t\t\t\t\t<integer>0</integer>\n'
      '\t\t\t\t</dict>\n'
      '\t\t\t</array>\n'
      '\t\t\t<key>Version</key>\n'
      '\t\t\t<string>1.0</string>\n'
      '\t\t</dict>\n'
      '\t</array>\n'
      '\t<key>MyAIM</key>\n'
      '\t<string></string>\n'
      '\t<key>MyColorHue</key>\n'
      '\t<real>1</real>\n'
      '\t<key>MyEmail</key>\n'
      '\t<string></string>\n'
      '\t<key>MyName</key>\n'
      '\t<string>Electric Bolt</string>\n'
      '\t<key>NSFixedPitchFont</key>\n'
      '\t<string>Menlo-Regular</string>\n'
      '\t<key>NSFixedPitchFontSize</key>\n'
      '\t<string>11</string>\n'
      '\t<key>NSNavLastRootDirectory</key>\n'
      '\t<string>~/Documents/Appfigurate/</string>\n'
      '\t<key>NSNavPanelExpandedSizeForOpenMode</key>\n'
      '\t<string>{712, 448}</string>\n'
      '\t<key>NSSplitView Subview Frames SiteListSplitView</key>\n'
      '\t<array>\n'
      '\t\t<string>0.000000, 0.000000, 393.000000, 468.000000, NO, NO</string>\n'
      '\t\t<string>394.000000, 0.000000, 267.000000, 468.000000, NO, NO</string>\n'
      '\t</array>\n'
      '\t<key>NSTableView Columns LocalOutlineViewAutosaveName</key>\n'
      '\t<array>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAhOU1N0cmluZwGEhAhOU09iamVjdACF\n'
      '\t\thAErBE5hbWWG\n'
      '\t\t</data>\n'
      '\t\t<string>313</string>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAhOU1N0cmluZwGEhAhOU09iamVjdACF\n'
      '\t\thAErBFNpemWG\n'
      '\t\t</data>\n'
      '\t\t<string>64</string>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAhOU1N0cmluZwGEhAhOU09iamVjdACF\n'
      '\t\thAErBERhdGWG\n'
      '\t\t</data>\n'
      '\t\t<string>118</string>\n'
      '\t</array>\n'
      '\t<key>NSTableView Hidden Columns LocalOutlineViewAutosaveName</key>\n'
      '\t<array/>\n'
      '\t<key>NSTableView Sort Ordering LocalOutlineViewAutosaveName</key>\n'
      '\t<array/>\n'
      '\t<key>PCUserNotificationCenterService</key>\n'
      '\t<integer>0</integer>\n'
      '\t<key>ParserExtensionMap</key>\n'
      '\t<data>\n'
      '\tYnBsaXN0MDDUAQIDBAUGGxxYJHZlcnNpb25YJG9iamVjdHNZJGFyY2hpdmVyVCR0b3AS\n'
      '\tAAGGoKUHCA0TF1UkbnVsbNIJCgsMV05TLnRpbWVWJGNsYXNzI0HACWl48dXLgALSDg8Q\n'
      '\tEVokY2xhc3NuYW1lWCRjbGFzc2VzVk5TRGF0ZaIQElhOU09iamVjdNIUChUWV05TLmRh\n'
      '\tdGFPEIAIwNzLEUASVmaryk2kYs+jMqAbHvPefT8eaBxeda7rm6ZSari4pTqohN2yWAcf\n'
      '\tqeTOFQQq60zaNsIVxxQD8DKnywoBzrxSFSv2UEcRcJv9qx9RdO85op4uoq4Lh3Z74Swj\n'
      '\t8mQJX6X9xWsr4guX6jTp/c3bBfkdy18v+ttVG+734IAE0g4PGBldTlNNdXRhYmxlRGF0\n'
      '\tYaMYGhJWTlNEYXRhXxAPTlNLZXllZEFyY2hpdmVy0x0eHyAhIldNYXBTaXplWkV4dGVu\n'
      '\tc2lvbnNaUGFyc2VyVHlwZRABgAGAAwAIABEAGgAjAC0AMgA3AD0AQwBIAFAAVwBgAGIA\n'
      '\tZwByAHsAggCFAI4AkwCbAR4BIAElATMBNwE+AVABVwFfAWoBdQF3AXkAAAAAAAACAQAA\n'
      '\tAAAAAAAjAAAAAAAAAAAAAAAAAAABew==\n'
      '\t</data>\n'
      '\t<key>PreferencesVersion</key>\n'
      '\t<string>2.0.14</string>\n'
      '\t<key>RecentDocumentSearches</key>\n'
      '\t<array>\n'
      '\t\t<string>jquery</string>\n'
      '\t</array>\n'
      '\t<key>SEEMode.ASP-HTML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.ActionScript</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n';

  var template3 =
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Base</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>PrintOptions</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSBottomMargin</key>\n'
      '\t\t\t<real>28.346457</real>\n'
      '\t\t\t<key>NSLeftMargin</key>\n'
      '\t\t\t<real>56.692913</real>\n'
      '\t\t\t<key>NSRightMargin</key>\n'
      '\t\t\t<real>28.346457</real>\n'
      '\t\t\t<key>NSTopMargin</key>\n'
      '\t\t\t<real>28.346457</real>\n'
      '\t\t\t<key>SEEAnnotateChangeMarks</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>SEEAnnotateWrittenBy</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>SEEColorizeChangeMarks</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>SEEColorizeWrittenBy</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>SEEFontAttributes</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t\t<string>Times-Roman</string>\n'
      '\t\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t\t<real>8.5</real>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>SEEHighlightSyntax</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEPageHeader</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEPageHeaderCurrentDate</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEPageHeaderFilename</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEParticipantImages</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEParticipants</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>SEEParticipantsAIMAndEmail</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEParticipantsVisitors</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEResizeDocumentFont</key>\n'
      '\t\t\t<true/>\n'
      '\t\t\t<key>SEEResizeDocumentFontTo</key>\n'
      '\t\t\t<real>8</real>\n'
      '\t\t\t<key>SEEUseCustomFont</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t\t<key>SEEWhiteBackground</key>\n'
      '\t\t\t<true/>\n'
      '\t\t</dict>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowBottomStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowTopStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.CFML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.CSS</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowBottomStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowTopStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Diff</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.ERB</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n';

  var template4 =
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.HTML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowBottomStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowTopStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.JSP-HTML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Java</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.JavaScript</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowBottomStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowTopStatusBar</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.LESS</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n';

  var template5 =
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.LassoScript-HTML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Lua</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Markdown</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Objective-J</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.PHP-HTML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n';

  var template6 =
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Perl</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Python</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Ruby</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.SCSS</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.SQL</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.Smarty</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n';

  var template7 =
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.XML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.YAML</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SEEMode.go</key>\n'
      '\t<dict>\n'
      '\t\t<key>BackgroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgEBhg==\n'
      '\t\t</data>\n'
      '\t\t<key>Columns</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Encoding</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>Export</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>HTML</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>AddCurrentDate</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>HighlightSyntax</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowAIMAndEmail</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowChangeMarks</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowParticipants</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowUserImages</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>ShowVisitors</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t\t<key>WrittenByHovers</key>\n'
      '\t\t\t\t<true/>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>FontAttributes</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>NSFontNameAttribute</key>\n'
      '\t\t\t<string>Menlo-Regular</string>\n'
      '\t\t\t<key>NSFontSizeAttribute</key>\n'
      '\t\t\t<real>11</real>\n'
      '\t\t</dict>\n'
      '\t\t<key>ForegroundColor</key>\n'
      '\t\t<data>\n'
      '\t\tBAtzdHJlYW10eXBlZIHoA4QBQISEhAdOU0NvbG9yAISECE5TT2JqZWN0AIWE\n'
      '\t\tAWMDhAJmZgABhg==\n'
      '\t\t</data>\n'
      '\t\t<key>HighlightSyntax</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentNewLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>IndentWrappedLinesCharacterAmount</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>LineEnding</key>\n'
      '\t\t<integer>1</integer>\n'
      '\t\t<key>PageGuideWidth</key>\n'
      '\t\t<integer>80</integer>\n'
      '\t\t<key>Rows</key>\n'
      '\t\t<integer>40</integer>\n'
      '\t\t<key>SelectionModifiers</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>\"</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t</dict>\n'
      "\t\t\t<key>'</key>\n"
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t\t<key>open</key>\n'
      "\t\t\t\t<string>'</string>\n"
      '\t\t\t</dict>\n'
      '\t\t\t<key>(</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>)</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>(</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>/</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>/&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>&lt;</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>&gt;</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>&lt;</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>@</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>\"</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>@\"</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>[</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>]</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>[</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>{</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>}</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>{</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>«</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>»</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>«</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>‘</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>’</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>‘</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>“</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t</dict>\n'
      '\t\t\t<key>„</key>\n'
      '\t\t\t<dict>\n'
      '\t\t\t\t<key>close</key>\n'
      '\t\t\t\t<string>“</string>\n'
      '\t\t\t\t<key>open</key>\n'
      '\t\t\t\t<string>„</string>\n'
      '\t\t\t</dict>\n'
      '\t\t</dict>\n'
      '\t\t<key>ShowInvisibleCharacters</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>ShowLineNumbers</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>ShowMatchingBrackets</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>StyleSheets</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>multiple</key>\n'
      '\t\t\t<dict/>\n'
      '\t\t\t<key>single</key>\n'
      '\t\t\t<string>Coda Bright</string>\n'
      '\t\t\t<key>usesMultiple</key>\n'
      '\t\t\t<false/>\n'
      '\t\t</dict>\n'
      '\t\t<key>TabKeyMovesToIndent</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>TabWidth</key>\n'
      '\t\t<integer>4</integer>\n'
      '\t\t<key>UTF8BOM</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseDefaultEdit</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFile</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultFont</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultPrint</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyle</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultStyleSheet</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseDefaultView</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>UseSelectionModifiers</key>\n'
      '\t\t<false/>\n'
      '\t\t<key>UseTabs</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapLines</key>\n'
      '\t\t<true/>\n'
      '\t\t<key>WrapMode</key>\n'
      '\t\t<integer>0</integer>\n'
      '\t</dict>\n'
      '\t<key>SUEnableAutomaticChecks</key>\n'
      '\t<true/>\n'
      '\t<key>SUFeedURL</key>\n'
      '\t<string>https://www.panic.com/updates/update.php</string>\n'
      '\t<key>SUHasLaunchedBefore</key>\n'
      '\t<true/>\n'
      '\t<key>SULastCheckTime</key>\n'
      '\t<date>2018-01-20T01:34:56Z</date>\n'
      '\t<key>SUSendProfileInfo</key>\n'
      '\t<false/>\n'
      '\t<key>SelectedSidebarIdentifier</key>\n'
      '\t<string>com.panic.miniFileBrowser</string>\n'
      '\t<key>SelectedSidebarTag</key>\n'
      '\t<integer>5</integer>\n'
      '\t<key>SerialNumber</key>\n'
      '\t<string>XXXX-PPPP-AAAA-YYYY-ZZZZ-N</string>\n'
      '\t<key>SidebarIsVisible</key>\n'
      '\t<true/>\n'
      '\t<key>SitesViewSize</key>\n'
      '\t<real>304</real>\n'
      '\t<key>SplitIsCollapsed</key>\n'
      '\t<false/>\n'
      '\t<key>SuppressAppleScriptDialogs</key>\n'
      '\t<false/>\n'
      '\t<key>ToolbarHeight</key>\n'
      '\t<real>100</real>\n'
      '\t<key>TransferRules2</key>\n'
      '\t<data>\n'
      '\tYnBsaXN0MDDUAQIDBAUGo6RYJHZlcnNpb25YJG9iamVjdHNZJGFyY2hpdmVyVCR0b3AS\n'
      '\tAAGGoK8QJQcIDhoeIiktLjQ5QUtMT1NXXF1gZGhsbXB4fICFio6RlJWYnJ9VJG51bGzS\n'
      '\tCQoLDVpOUy5vYmplY3RzViRjbGFzc6EMgAKAE9YPChAREhMUFRYXGBlWYWN0aW9uV2Vu\n'
      '\tYWJsZWRUbmFtZVlwcmVkaWNhdGVUdXVpZBAAgCQIgAeACIAD0gobHB1UVVVJRIAGgATS\n'
      '\tCh8gIVlOUy5zdHJpbmeABV8QJDg0OTBGQTZGLTE3Q0UtNEJCRC04NTAxLUJGMjVDRTU2\n'
      '\tOThBNdIjJCUmWiRjbGFzc25hbWVYJGNsYXNzZXNfEA9OU011dGFibGVTdHJpbmejJSco\n'
      '\tWE5TU3RyaW5nWE5TT2JqZWN00iMkKitWUENVVUlEoiwoVlBDVVVJRF8QHlNvdXJjZSBD\n'
      '\tb250cm9sIEZpbGVzIChFeGFtcGxlKdMvMAoxMjNfEBdOU0NvbXBvdW5kUHJlZGljYXRl\n'
      '\tVHlwZV8QD05TU3VicHJlZGljYXRlcxACgAmAI9IJCjU4ojY3gAqAG4Ai1Ao6Ozw9Pj9A\n'
      '\tXxARTlNSaWdodEV4cHJlc3Npb25fEBBOU0xlZnRFeHByZXNzaW9uXxATTlNQcmVkaWNh\n'
      '\tdGVPcGVyYXRvcoAagBWAC4AY1UJDREUKRkdISUpZTlNPcGVyYW5kXk5TU2VsZWN0b3JO\n'
      '\tYW1lXxAQTlNFeHByZXNzaW9uVHlwZVtOU0FyZ3VtZW50c4ANgAwQA4APgBRcdmFsdWVG\n'
      '\tb3JLZXk60kQKTU4QAYAO0iMkUFFfEBBOU1NlbGZFeHByZXNzaW9uo1BSKFxOU0V4cHJl\n'
      '\tc3Npb27SCQpUDaFVgBCAE9MKRFhZWltZTlNLZXlQYXRogBIQCoARW2Rpc3BsYXlOYW1l\n'
      '\t0iMkXl9fEBxOU0tleVBhdGhTcGVjaWZpZXJFeHByZXNzaW9uo15SKNIjJGFiXk5TTXV0\n'
      '\tYWJsZUFycmF5o2FjKFdOU0FycmF50iMkZWZfEBNOU0tleVBhdGhFeHByZXNzaW9upGVn\n'
      '\tUihfEBROU0Z1bmN0aW9uRXhwcmVzc2lvbtNpRApqFGtfEA9OU0NvbnN0YW50VmFsdWWA\n'
      '\tFoAXVC5zdm7SIyRub18QGU5TQ29uc3RhbnRWYWx1ZUV4cHJlc3Npb26jblIo1QpxcnN0\n'
      '\tdRQWFHdaTlNNb2RpZmllclhOU05lZ2F0ZVlOU09wdGlvbnNeTlNPcGVyYXRvclR5cGWA\n'
      '\tGQgQBNIjJHl6XxAbTlNFcXVhbGl0eVByZWRpY2F0ZU9wZXJhdG9yo3l7KF8QE05TUHJl\n'
      '\tZGljYXRlT3BlcmF0b3LSIyR9fl8QFU5TQ29tcGFyaXNvblByZWRpY2F0ZaN9fyhbTlNQ\n'
      '\tcmVkaWNhdGXUCjo7PD2Cg4SAGoAfgByAIdVCQ0RFCkZHSIhKgA2ADIAdgBTSCQqLDaGM\n'
      '\tgB6AE9MKRFhZWluAEoAR02lECpIUa4AggBdULmdpdNUKcXJzdHUUFhR3gBkI0iMkmZpX\n'
      '\tTlNBcnJheaKbKFdOU0FycmF50iMknZ5fEBNOU0NvbXBvdW5kUHJlZGljYXRlo51/KNIj\n'
      '\tJKChXxAQUENQcmVkaWNhdGVHcm91cKKiKF8QEFBDUHJlZGljYXRlR3JvdXBfEA9OU0tl\n'
      '\teWVkQXJjaGl2ZXLRpaZUcm9vdIABAAgAEQAaACMALQAyADcAXwBlAGoAdQB8AH4AgACC\n'
      '\tAI8AlgCeAKMArQCyALQAtgC3ALkAuwC9AMIAxwDJAMsA0ADaANwBAwEIARMBHAEuATIB\n'
      '\tOwFEAUkBUAFTAVoBewGCAZwBrgGwAbIBtAG5AbwBvgHAAcIBywHfAfICCAIKAgwCDgIQ\n'
      '\tAhsCJQI0AkcCUwJVAlcCWQJbAl0CagJvAnECcwJ4AosCjwKcAqECowKlAqcCrgK4AroC\n'
      '\tvAK+AsoCzwLuAvIC9wMGAwoDEgMXAy0DMgNJA1ADYgNkA2YDawNwA4wDkAObA6YDrwO5\n'
      '\tA8gDygPLA80D0gPwA/QECgQPBCcEKwQ3BEAEQgREBEYESARTBFUEVwRZBFsEYARiBGQE\n'
      '\tZgRtBG8EcQR4BHoEfASBBIwEjgSPBJQEnASfBKcErATCBMYEywTeBOEE9AUGBQkFDgAA\n'
      '\tAAAAAAIBAAAAAAAAAKcAAAAAAAAAAAAAAAAAAAUQ\n'
      '\t</data>\n'
      '\t<key>TransferRules3</key>\n'
      '\t<data>\n'
      '\tYnBsaXN0MDDUAQIDBAUGoKFYJHZlcnNpb25YJG9iamVjdHNZJGFyY2hpdmVyVCR0b3AS\n'
      '\tAAGGoK8QJQcIDhoeIiksLTM4QEpLTlJWW1xfY2drbG93e3+EiY2Qk5SXmZxVJG51bGzS\n'
      '\tCQoLDVpOUy5vYmplY3RzViRjbGFzc6EMgAKAE9YPChAREhMUFRYXGBlWYWN0aW9uV2Vu\n'
      '\tYWJsZWRUbmFtZVlwcmVkaWNhdGVUdXVpZBAAgCQIgAeACIAD0gobHB1UVVVJRIAGgATS\n'
      '\tCh8gIVlOUy5zdHJpbmeABV8QJEQ4MUMyQ0VBLTg4NzUtNEJFRS1CQTk3LUM5N0I0OTQw\n'
      '\tRDhEMdIjJCUmWiRjbGFzc25hbWVYJGNsYXNzZXNfEA9OU011dGFibGVTdHJpbmejJSco\n'
      '\tWE5TU3RyaW5nWE5TT2JqZWN00iMkKitWUENVVUlEoiooXxAeU291cmNlIENvbnRyb2wg\n'
      '\tRmlsZXMgKEV4YW1wbGUp0y4vCjAxMl8QF05TQ29tcG91bmRQcmVkaWNhdGVUeXBlXxAP\n'
      '\tTlNTdWJwcmVkaWNhdGVzEAKACYAj0gkKNDeiNTaACoAbgCLUCjk6Ozw9Pj9fEBFOU1Jp\n'
      '\tZ2h0RXhwcmVzc2lvbl8QEE5TTGVmdEV4cHJlc3Npb25fEBNOU1ByZWRpY2F0ZU9wZXJh\n'
      '\tdG9ygBqAFYALgBjVQUJDRApFRkdISVlOU09wZXJhbmReTlNTZWxlY3Rvck5hbWVfEBBO\n'
      '\tU0V4cHJlc3Npb25UeXBlW05TQXJndW1lbnRzgA2ADBADgA+AFFx2YWx1ZUZvcktleTrS\n'
      '\tQwpMTRABgA7SIyRPUF8QEE5TU2VsZkV4cHJlc3Npb26jT1EoXE5TRXhwcmVzc2lvbtIJ\n'
      '\tClMNoVSAEIAT0wpDV1hZWllOU0tleVBhdGiAEhAKgBFbZGlzcGxheU5hbWXSIyRdXl8Q\n'
      '\tHE5TS2V5UGF0aFNwZWNpZmllckV4cHJlc3Npb26jXVEo0iMkYGFeTlNNdXRhYmxlQXJy\n'
      '\tYXmjYGIoV05TQXJyYXnSIyRkZV8QE05TS2V5UGF0aEV4cHJlc3Npb26kZGZRKF8QFE5T\n'
      '\tRnVuY3Rpb25FeHByZXNzaW9u02hDCmkUal8QD05TQ29uc3RhbnRWYWx1ZYAWgBdULnN2\n'
      '\tbtIjJG1uXxAZTlNDb25zdGFudFZhbHVlRXhwcmVzc2lvbqNtUSjVCnBxcnN0FBYUdlpO\n'
      '\tU01vZGlmaWVyWE5TTmVnYXRlWU5TT3B0aW9uc15OU09wZXJhdG9yVHlwZYAZCBAE0iMk\n'
      '\teHlfEBtOU0VxdWFsaXR5UHJlZGljYXRlT3BlcmF0b3KjeHooXxATTlNQcmVkaWNhdGVP\n'
      '\tcGVyYXRvctIjJHx9XxAVTlNDb21wYXJpc29uUHJlZGljYXRlo3x+KFtOU1ByZWRpY2F0\n'
      '\tZdQKOTo7PIGCg4AagB+AHIAh1UFCQ0QKRUZHh0mADYAMgB2AFNIJCooNoYuAHoAT0wpD\n'
      '\tV1hZWoASgBHTaEMKkRRqgCCAF1QuZ2l01QpwcXJzdBQWFHaAGQjSIyRimKJiKNIjJJqb\n'
      '\tXxATTlNDb21wb3VuZFByZWRpY2F0ZaOafijSIySdnl8QEFBDUHJlZGljYXRlR3JvdXCi\n'
      '\tnyhfEBBQQ1ByZWRpY2F0ZUdyb3VwXxAPTlNLZXllZEFyY2hpdmVy0aKjVHJvb3SAAQAI\n'
      '\tABEAGgAjAC0AMgA3AF8AZQBqAHUAfAB+AIAAggCPAJYAngCjAK0AsgC0ALYAtwC5ALsA\n'
      '\tvQDCAMcAyQDLANAA2gDcAQMBCAETARwBLgEyATsBRAFJAVABUwF0AXsBlQGnAakBqwGt\n'
      '\tAbIBtQG3AbkBuwHEAdgB6wIBAgMCBQIHAgkCFAIeAi0CQAJMAk4CUAJSAlQCVgJjAmgC\n'
      '\tagJsAnEChAKIApUCmgKcAp4CoAKnArECswK1ArcCwwLIAucC6wLwAv8DAwMLAxADJgMr\n'
      '\tA0IDSQNbA10DXwNkA2kDhQOJA5QDnwOoA7IDwQPDA8QDxgPLA+kD7QQDBAgEIAQkBDAE\n'
      '\tOQQ7BD0EPwRBBEwETgRQBFIEVARZBFsEXQRfBGYEaARqBHEEcwR1BHoEhQSHBIgEjQSQ\n'
      '\tBJUEqwSvBLQExwTKBN0E7wTyBPcAAAAAAAACAQAAAAAAAACkAAAAAAAAAAAAAAAAAAAE\n'
      '\t+Q==\n'
      '\t</data>\n'
      '\t<key>UploadPermissionsMap</key>\n'
      '\t<dict>\n'
      '\t\t<key>--\$\$PCDefaultFile\$\$--</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Enabled</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>Permissions</key>\n'
      '\t\t\t<integer>644</integer>\n'
      '\t\t\t<key>S3Permissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t\t<key>WebDAVPermissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t</dict>\n'
      '\t\t<key>--\$\$PCDefaultFolder\$\$--</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Enabled</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>Permissions</key>\n'
      '\t\t\t<integer>755</integer>\n'
      '\t\t\t<key>S3Permissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t\t<key>WebDAVPermissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t</dict>\n'
      '\t\t<key>cgi</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Enabled</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>Permissions</key>\n'
      '\t\t\t<integer>755</integer>\n'
      '\t\t\t<key>S3Permissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t\t<key>WebDAVPermissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t</dict>\n'
      '\t\t<key>pl</key>\n'
      '\t\t<dict>\n'
      '\t\t\t<key>Enabled</key>\n'
      '\t\t\t<false/>\n'
      '\t\t\t<key>Permissions</key>\n'
      '\t\t\t<integer>755</integer>\n'
      '\t\t\t<key>S3Permissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t\t<key>WebDAVPermissions</key>\n'
      '\t\t\t<integer>0</integer>\n'
      '\t\t</dict>\n'
      '\t</dict>\n'
      '\t<key>WebIconDatabaseDirectoryDefaultsKey</key>\n'
      '\t<string>/Users/ElectricBolt/Library/Application Support/Coda 2</string>\n'
      '\t<key>WebKit Web Inspector Setting - inspectorAttachedHeight</key>\n'
      '\t<string>425</string>\n'
      '\t<key>WebKitLocalStorageDatabasePathPreferenceKey</key>\n'
      '\t<string>/Users/ElectricBolt/Library/Application Support/Coda 2</string>\n'
      '\t<key>sidebarSplitPercentage</key>\n'
      '\t<real>0.21747498</real>\n'
      '\t<key>soapBox.displayedID</key>\n'
      '\t<string>coda25-11-03-2014-001</string>\n'
      '</dict>\n'
      '</plist>\n';

  test('com_panic_Coda2_XML', () {
    var combinedTemplate = template + template2 + template3 + template4 + template5 + template6 + template7;

    var rootDict = PropertyListSerialization.propertyListWithString(
      combinedTemplate) as Map<String,Object>;

    // Convert the object graph back into a plist.
    var newStr = PropertyListSerialization.stringWithPropertyList(rootDict);

    // The newly generated plist output from dataWithPropertyList should exactly match the template string.
    expect(combinedTemplate, equals(newStr));
  });

  test('com_panic_Coda2_Binary', () {
    var combinedTemplate = template + template2 + template3 + template4 + template5 + template6 + template7;

    // Convert the plist into an object graph.
    var rootDict = PropertyListSerialization.propertyListWithString(
        combinedTemplate) as Map<String,Object>;

    // Convert the object graph into a binary plist.
    var newBuf = PropertyListSerialization.dataWithPropertyList(rootDict);

    // Convert the binary plist back into an object graph.
    rootDict = PropertyListSerialization.propertyListWithData(newBuf) as
      Map<String, Object>;

    // Convert the object graph back into a string plist.
    var newStr = PropertyListSerialization.stringWithPropertyList(rootDict);

    // The newly generated plist output from dataWithPropertyList should exactly
    // match the template string.
    if (combinedTemplate != newStr) {
      fail('Did not match, combinedTemplate.length=${combinedTemplate.length}, '
          'newStr.length=${newStr.length}');
    }
  });

}